commit 1dd77eeccc2941323607e88a6fe37625a2dc6698
Author: Jakub Jelinek <jakub@redhat.com>
Date:   Thu Apr 23 09:54:14 2020 +0200

    attribs: Don't diagnose attribute exclusions during error recovery [PR94705]
    
    On the following testcase GCC ICEs, because last_decl is error_mark_node,
    and diag_attr_exclusions assumes that if it is not NULL, it must be a decl.
    
    The following patch just doesn't diagnose attribute exclusions if the
    other decl is erroneous (and thus we've already reported errors for it).
    
    2020-04-23  Jakub Jelinek  <jakub@redhat.com>
    
            PR c/94705
            * attribs.c (decl_attribute): Don't diagnose attribute exclusions
            if last_decl is error_mark_node or has such a TREE_TYPE.
    
            * gcc.dg/pr94705.c: New test.
    
    (cherry picked from commit e2a71816b4949225498bec37e947293aa7f5841b)

diff --git a/gcc/attribs.c b/gcc/attribs.c
index fc21f799d92..4db4052ec15 100644
--- a/gcc/attribs.c
+++ b/gcc/attribs.c
@@ -702,7 +702,8 @@ decl_attributes (tree *node, tree attributes, int flags,
       bool built_in = flags & ATTR_FLAG_BUILT_IN;
       if (spec->exclude
 	  && !no_add_attrs
-	  && (flag_checking || !built_in))
+	  && (flag_checking || !built_in)
+	  && !error_operand_p (last_decl))
 	{
 	  /* Always check attributes on user-defined functions.
 	     Check them on built-ins only when -fchecking is set.
diff --git a/gcc/testsuite/gcc.dg/pr94705.c b/gcc/testsuite/gcc.dg/pr94705.c
new file mode 100644
index 00000000000..96392ab60ee
--- /dev/null
+++ b/gcc/testsuite/gcc.dg/pr94705.c
@@ -0,0 +1,13 @@
+/* PR c/94705 */
+/* { dg-do compile } */
+/* { dg-options "" } */
+
+void foo ();
+
+int
+bar (void)
+{
+  foo (baz);	/* { dg-error "'baz' undeclared" } */
+		/* { dg-message "only once" "" { target *-*-* } .-1 } */
+  void __attribute__ ((noinline)) baz (void);
+}

